from django.shortcuts import render
from django.http import HttpResponse
from . models import Questions
from django.core.paginator import Paginator
from .forms import UploadFileForm
from django.http import HttpResponseRedirect
from .models import submission
from . newQuiz import readCSV
import csv
lst = []

answers = Questions.objects.all()
anslist = []
marksList=[]
negative=[]
for i in answers:
    print(str(i.answer)+" "+str(i.negative)+" "+str(i.marks))
    anslist.append(i.answer)
    marksList.append(i.marks)
    negative.append(i.negative)

def index(request):
    obj = Questions.objects.get_queryset().order_by('questionId')
    count = Questions.objects.all().count()
    paginator = Paginator(obj,1)
    try:
       page = int(request.GET.get('page','1'))  
    except:
        page =1
    try:
        questions = paginator.page(page)
    except Exception as e:

        questions=paginator.page(paginator.num_pages)
    
    return render(request,'index.html',{'obj':obj,'questions':questions,'count':count})
'''
def index(request):
    pass
'''
def result(request):
    score =0
    #print("lstlstlst"+str(len(anslist)))
    for i in range(len(lst)):
        if  lst[i]==anslist[i]:
        	score +=marksList[i]
        else:
            score-=negative[i]
    return render(request,'result.html',{'score':score,'lst':lst,'anslist':anslist})
    
    
def save_ans(request):
    ans = request.GET['ans']
    quizId=request.GET['quizId']
    questionId=request.GET['questionId']
    studentId=1# initialize here student id
    t=submission(questionId=questionId,option=ans,quizId=quizId,studentId=studentId)
    t.save()
    lst.append(ans)
    return HttpResponse('')
    
def upload(request):
    return render(request,'upload.html')


def student(request):
    lst.clear()
    return render(request,'student.html')

def upload_file(request):
    uploaded=False
    temp1='test'
    form = UploadFileForm(request.POST, request.FILES)
    if request.method == 'POST' and form.is_valid():
        handle_uploaded_file(request.FILES['file'])
        uploaded=True
        return HttpResponse('success')
        
    else :
        return render(request,'upload.html',{temp1:'invalid File'})
    
    

def handle_uploaded_file(f):
    with open('name.csv', 'wb+') as destination:
        for chunk in f.chunks():
            destination.write(chunk)
    destination=open("name.csv","r") 
    rows=readCSV(destination)
    for row in rows:
        print(str(row))
        q=Questions(question=row[0],option1=row[1],option2=row[2],option3=row[3],option4=row[4],answer=row[5],type=row[6],marks=int(row[7]),negative=float(row[8]),explainations=row[9],quizId=row[10])
        q.save()


